package com.jkcredit.invoice.controller.service;

import com.jkcredit.invoice.service.lowerService.SelfCarServiceL;
import com.jkcredit.invoice.service.lowerService.vo.InvoiceApplVo;
import com.jkcredit.invoice.service.lowerService.vo.SelfCarDueQueryVo;
import com.jkcredit.invoice.service.lowerService.vo.TradeRequestVo;
import com.jkcredit.invoice.util.RespR;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@Api(tags = "自有车下游接口")
@RestController
@RequestMapping(value = {"/selfCarService"})
public class SelfCarServiceController {
    @Autowired
    SelfCarServiceL selfCarService;
    /**
     * @param tradeRequestVo
     * @return
     */
    @PostMapping("/getTradeList")
    @ApiOperation(value="获取交易Id列表", notes="获取交易Id列表")
    //@LoginRequired
    public RespR getTradeList(@RequestBody TradeRequestVo tradeRequestVo){
        return selfCarService.getTradeList(tradeRequestVo);
    }

    /**
     * @param invoiceApplVo
     * @return
     */
    @PostMapping("/applInvoice")
    @ApiOperation(value="开票申请", notes="开票申请")
    //@LoginRequired
    public RespR applInvoice(@RequestBody InvoiceApplVo invoiceApplVo){
        return selfCarService.applInvoice(invoiceApplVo);
    }

    /**
     * @param selfCarDueQueryVo
     * @return
     */
    @PostMapping("/getSelfCarInvoicesByTime")
    @ApiOperation(value="已开发票查询", notes="已开发票查询")
    //@LoginRequired
    public RespR getSelfCarInvoicesByTime(@RequestBody SelfCarDueQueryVo selfCarDueQueryVo){
        return selfCarService.getSelfCarInvoicesByTime(selfCarDueQueryVo);
    }
}
