package com.jkcredit.invoice.service.lowerService;

import com.jkcredit.invoice.model.entity.customer.CustomerCarRec;
import com.jkcredit.invoice.model.entity.customer.CustomerRec;
import com.jkcredit.invoice.util.RespR;

import java.util.List;

/**
 * 下游客户接口服务类
 */
public interface CustomeLowerService {
    /**
     * 客户备案
     * @param customerRecs
     * @return
     */
    RespR customeRec(List<CustomerRec> customerRecs);

    /**
     * 客户备案列表查询（本地库）
     * @param customerRec
     * @return
     */
    RespR customeRecQueryList(CustomerRec customerRec);

    /**
     * 客户备案查询(本地库)
     * @param customerRec
     * @return
     */
    RespR customeRecQuery(CustomerRec customerRec);

    /**
     * 车辆备案
     * @param customerCarRec
     * @return
     */
    RespR customerCarRec(List<CustomerCarRec> customerCarRec);

    /**
     * 车辆解绑
     * @param customerCarRec
     * @return
     */
    RespR customerCarUnRec(List<CustomerCarRec> customerCarRec);

    /**
     * 无车车辆备案查询
     * @param customerCarRec
     * @return
     */
    RespR customerCarRecQuery(CustomerCarRec customerCarRec);
}
