package com.jkcredit.invoice.service.lowerService;

import com.jkcredit.invoice.model.entity.invoice.SelfCarAppl;
import com.jkcredit.invoice.model.entity.invoice.SelfCarInvoice;
import com.jkcredit.invoice.model.entity.waybill.SelfCarTrade;
import com.jkcredit.invoice.service.lowerService.vo.InvoiceApplVo;
import com.jkcredit.invoice.service.lowerService.vo.SelfCarDueQueryVo;
import com.jkcredit.invoice.service.lowerService.vo.TradeRequestVo;
import com.jkcredit.invoice.util.RespR;

import java.util.List;

/**
 * 自有车掉上游接口服务
 */
public interface SelfCarServiceL {
    /**
     * 获取交易列表
     *
     * @param tradeRequestVo
     * @return
     */
    RespR<List<SelfCarTrade>> getTradeList(TradeRequestVo tradeRequestVo);

    /**
     * 开票申请接口
     * @param invoiceApplVo
     * @return
     */
    RespR<Boolean> applInvoice(InvoiceApplVo invoiceApplVo);

    /**
     *按申请id取发票
     */
    RespR<List<SelfCarInvoice>> getSelfCarInvoicesByApplyIds(SelfCarAppl selfCarAppl);

    /**
     *已开发票查询接口
     */
    RespR<List<SelfCarInvoice>> getSelfCarInvoicesByTime(SelfCarDueQueryVo selfCarDueQueryVo);

}