package com.jkcredit.invoice.service.lowerService.impl;

import cn.com.taiji.sdk.model.comm.protocol.tts.card.server.*;
import cn.com.taiji.sdk.model.comm.protocol.tts.vehicle.VehicleRegisterRequest;
import cn.com.taiji.sdk.model.comm.protocol.tts.vehicle.VehicleRegisterResponse;
import com.jkcredit.invoice.mapper.customer.CustomerCarRecMapper;
import com.jkcredit.invoice.mapper.customer.CustomerMapper;
import com.jkcredit.invoice.mapper.customer.CustomerRecMapper;
import com.jkcredit.invoice.model.entity.customer.Customer;
import com.jkcredit.invoice.model.entity.customer.CustomerCarRec;
import com.jkcredit.invoice.model.entity.customer.CustomerRec;
import com.jkcredit.invoice.service.lowerService.CustomeLowerService;
import com.jkcredit.invoice.service.upService.NoCarInterface;
import com.jkcredit.invoice.service.upService.SelfCarInterface;
import com.jkcredit.invoice.util.DateUtil;
import com.jkcredit.invoice.util.RespR;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.StringUtils;

import java.util.ArrayList;
import java.util.List;

@Service("lowerService")
public class CustomerLowerServiceImpl implements CustomeLowerService {
    @Autowired
    CustomerMapper customerMapper;

    @Autowired
    CustomerRecMapper customerRecMapper;

    @Autowired
    CustomerCarRecMapper customerCarRecMapper;

    @Autowired
    NoCarInterface noCarInterface;

    @Autowired
    SelfCarInterface selfCarInterface;
    @Override
    public RespR customeRec(List<CustomerRec> customerRecs) {

        if(customerRecs==null || customerRecs.size()<=0){return new RespR(false,"备案信息为空");};
        StringBuffer res = new StringBuffer();
        customerRecs.stream().forEach(customerRec -> {
            Customer customer = customerMapper.selectByCustomerName(customerRec.getCustomerName());
            if(customer == null || customer.getAccstatus()!=0){
                res.append(customerRec.getCustomerName()+"不存在或已经停用;");
                return;
            }
            //默认备案状态为备案中 0 -备案中 1.备案失败 2.备案完成
            customerRec.setRecStatus(0);
            //客户备案信息入表
            CustomerRec customerRec1 = customerRecMapper.selectByCustomerNameAndCompany(customerRec);
            customerRec.setCreatetime(DateUtil.getCurrentDateStr());
            customerRec.setCompanyBelongName(customerRec.getCompanyName());
            if(customerRec1 == null){
                customerRecMapper.insert(customerRec);
            }else{
                customerRec.setId(customerRec1.getId());
                customerRecMapper.updateByPrimaryKey(customerRec);
            }
        });
        if(StringUtils.isEmpty(res.toString())){
            return new RespR(true,"成功");
        }else{
            return new RespR(false,res.toString());
        }

    }

    @Override
    public RespR customeRecQueryList(CustomerRec customerRec) {

        return new RespR(customerRecMapper.selectByCustomerName(customerRec.getCustomerName()));
    }
    @Override
    public RespR customeRecQuery(CustomerRec customerRec) {

        return new RespR(customerRecMapper.selectByCustomerNameAndCompany(customerRec));
    }
    @Override
    public RespR customerCarRec(List<CustomerCarRec> customerCarRecs) {
        if(customerCarRecs== null || customerCarRecs.size()<=0){
            return new RespR(false,"无备案车辆");
        }
        StringBuffer res = new StringBuffer();
        CustomerCarRec customerCarRec2 = customerCarRecs.get(0);
        Customer customer = customerMapper.selectByCustomerName(customerCarRec2.getCustomerName());
        if(customer == null || customer.getAccstatus()!=0){
            res.append("#客户："+customerCarRec2.getCustomerName()+"不存在或状态异常");
            return new RespR(false,res.toString());
        }
        CustomerRec customerRecP = new CustomerRec();
        customerRecP.setCustomerName(customerCarRec2.getCustomerName());
        customerRecP.setCompanyName(customerCarRec2.getCompanyName());
        CustomerRec customerRec = customerRecMapper.selectByCustomerNameAndCompany(customerRecP);
        if(customerRec == null){
            res.append("#客户："+customerCarRec2.getCustomerName()+"企业:"+customerCarRec2.getCompanyName()+"备案信息不存在");
            return new RespR(false,res.toString());
        }
        if("0".equals(customerCarRec2.getBusinessType())){
            boolean isValidate = false;
            if(!StringUtils.isEmpty(customerCarRec2.getValidateCode())){
                isValidate = true;
            }
            return customerCarrRecForSelfCar(customerCarRecs,res,customerRec,isValidate);
        }else if("2".equals(customerCarRec2.getBusinessType())){
            return customerCarRecForNoCar(customerCarRecs,res,customerRec);
        }
        return new RespR(false,"业务类型不支持");
    }
    public RespR customerCarrRecForSelfCar(List<CustomerCarRec> customerCarRecs,StringBuffer res,CustomerRec customerRec,boolean isValid){
        List<CardBindingToBModel> cardBindingToBModels = new ArrayList<>();
        try {
            if(isValid){
                //校验
                CardValidCodeToBRequest cardValidCodeToBRequest = new CardValidCodeToBRequest();
                cardValidCodeToBRequest.setCompanyNum(customerRec.getCompanyNum());
                cardValidCodeToBRequest.setMobile(customerRec.getCompanyPhone());
                cardValidCodeToBRequest.setValidCode(customerCarRecs.get(0).getValidateCode());
                RespR<CardValidCodeToBResponse> respR = selfCarInterface.cardValidCodeToB(cardValidCodeToBRequest);
                if(respR.getCode() == 1){
                    for(CustomerCarRec customerCarRec:customerCarRecs){
                        customerCarRec.setRecStatus(0);
                        customerCarRec.setFailReason(respR.getMsg());
                        customerCarRec.setFailTime(DateUtil.getCurrentDateStr());
                        updateCustomerCarRec(customerCarRec);
                    }
                    return new RespR(false,"验证失败");
                }else{
                    for(CustomerCarRec customerCarRec:customerCarRecs){
                        if(!customerRec.getBussinessType().equals(customerCarRec.getBusinessType())){
                            res.append("#客户："+customerCarRec.getCustomerName()+"企业:"+customerCarRec.getCompanyName()+"车辆:"+customerCarRec.getCarNum()+"业务类型错误");
                            continue;
                        }
                        customerCarRec.setRecStatus(1);
                        customerCarRec.setSuccTime(DateUtil.getCurrentDateStr());
                        updateCustomerCarRec(customerCarRec);
                    }
                    if(StringUtils.isEmpty(res.toString())) {
                        return new RespR("绑定成功");
                    }else{
                        return new RespR(false,res.toString());
                    }
                }

            }else{
                for(CustomerCarRec customerCarRec:customerCarRecs){

                    if(!customerRec.getBussinessType().equals(customerCarRec.getBusinessType())){
                        res.append("#客户："+customerCarRec.getCustomerName()+"企业:"+customerCarRec.getCompanyName()+"etc:"+customerCarRec.getEtcNum()+"业务类型错误");
                        throw new Exception(res.toString());
                    }
                    CardBindingToBModel cardBindingToBModel = new CardBindingToBModel();
                    cardBindingToBModel.setCardId(customerCarRec.getEtcNum());
                    cardBindingToBModels.add(cardBindingToBModel);
                }
                CardBindingToBRequest cardBindingToBRequest = new CardBindingToBRequest();
                cardBindingToBRequest.setMobile(customerRec.getCompanyPhone());
                cardBindingToBRequest.setCompanyNum(customerRec.getCompanyNum());
                cardBindingToBRequest.setCardIdList(cardBindingToBModels);
                RespR<CardBindingToBResponse> respR = selfCarInterface.cardBindingToB(cardBindingToBRequest);
                if(respR.getCode() == 1){
                    return new RespR(false,"注册失败："+respR.getMsg());
                }else{
                    return new RespR("已经发送绑定请求，请发送收到的验证码");
                }
            }
        }catch (Exception e){
            e.printStackTrace();
            return new RespR(false,e.getMessage());
        }


    }
    public void updateCustomerCarRec(CustomerCarRec customerCarRec){
        //根据车牌号查询是新增还是更新
        CustomerCarRec customerCarRec1 = customerCarRecMapper.selectByCarNum(customerCarRec.getCarNum());
        customerCarRec.setRecStatus(0);
        customerCarRec.setFailTime(DateUtil.getCurrentDateStr());
        if (customerCarRec1 == null) {
            customerCarRecMapper.insert(customerCarRec);
        } else {
            customerCarRecMapper.updateByPrimaryKey(customerCarRec);
        }
    }
    @Transactional
    public  RespR customerCarRecForNoCar(List<CustomerCarRec> customerCarRecs,StringBuffer res,CustomerRec customerRec) {
        try {

            for (CustomerCarRec customerCarRec : customerCarRecs) {
                if(!customerRec.getBussinessType().equals(customerCarRec.getBusinessType())){
                    res.append("#客户："+customerCarRec.getCustomerName()+"企业:"+customerCarRec.getCompanyName()+"车辆:"+customerCarRec.getCarNum()+"业务类型错误");
                   continue;
                }
                //如果业务类型是无车
                VehicleRegisterRequest vehicleRegisterRequest = new VehicleRegisterRequest();
                vehicleRegisterRequest.setCompanyName(customerCarRec.getCompanyName());
                vehicleRegisterRequest.setCompanyNum(customerRec.getCompanyNum());
                vehicleRegisterRequest.setPlateColor(Integer.parseInt(customerCarRec.getCarColor()));
                vehicleRegisterRequest.setPlateNum(customerCarRec.getCarNum());
                RespR<VehicleRegisterResponse> respR = noCarInterface.vehicleRegister(vehicleRegisterRequest);
                if (respR.getCode() == 1) {
                    res.append("#客户：" + customerCarRec.getCustomerName() + "企业:" + customerCarRec.getCompanyName() + "车辆:" + customerCarRec.getCarNum() + "注册失败，原因：" + respR.getMsg());
                    customerCarRec.setRecStatus(0);
                    customerCarRec.setFailReason(respR.getMsg());
                    customerCarRec.setFailTime(DateUtil.getCurrentDateStr());
                } else {
                    customerCarRec.setRecStatus(1);
                    customerCarRec.setSuccTime(DateUtil.getCurrentDateStr());
                }
                //根据车牌号查询是新增还是更新
                updateCustomerCarRec(customerCarRec);

            }
            if(StringUtils.isEmpty(res.toString())){
                return new RespR("成功");
            }else {
                return new RespR(false,res.toString());
            }

        }catch (Exception e){
            e.printStackTrace();
            return new RespR(false,e.getMessage());
        }

    }
    @Override
    public RespR customerCarRecQuery(CustomerCarRec customerCarRec) {

        return new RespR(customerCarRecMapper.selectByCustName(customerCarRec.getCustomerName()));
    }

    @Override
    public RespR customerCarUnRec(List<CustomerCarRec> customerCarRecs) {
        if(customerCarRecs!=null || customerCarRecs.size()<=0){
            return new RespR(false,"无解绑信息");
        }
        StringBuffer res = new StringBuffer();
        try {
            for(CustomerCarRec customerCarRec:customerCarRecs){
                if("0".equals(customerCarRec.getBusinessType())){
                    CardUnbindToBRequest cardUnbindToBRequest = new CardUnbindToBRequest();
                    cardUnbindToBRequest.setCardId(customerCarRec.getEtcNum());
                    cardUnbindToBRequest.setCompanyNum(customerCarRec.getCarNum());
                    RespR<CardUnbindToBResponse> respR = selfCarInterface.cardUnbindToB(cardUnbindToBRequest);
                    if(respR.getCode() == 1){
                        res.append(customerCarRec.getEtcNum()+","+customerCarRec.getCarNum()+"解绑失败;"+"#");
                    }else{
                        customerCarRec.setRecStatus(2);
                        customerCarRecMapper.updateByPrimaryKeySelective(customerCarRec);
                    }
                }
            }
            if(StringUtils.isEmpty(res.toString())){
                return new RespR("解绑成功");
            }else{
                return new RespR(false,res.toString());
            }

        }catch (Exception e){
            return new RespR(false,e.getMessage());
        }

    }

}
